\section{Current Work}
\label{sec:current_work}

In this section, we present our ongoing work and future plans, with a primary focus on integrating the Adversarial Observation framework into our proposed MLOP development cycle to address its limitations effectively.

\subsection{Addressing Energy Efficiency}

Our ongoing efforts are dedicated to rigorously assessing energy efficiency using diverse pruning metrics and datasets, with the BUTTER dataset \cite{butter_publication, butter_dataset} serving as a foundational resource. The BUTTER dataset, known as \textit{Better Understanding of Training Topologies through Empirical Research}, provides a rich and empirical exploration of deep learning phenomena on fully-connected networks. Researchers and practitioners can leverage this comprehensive dataset to gain deeper insights into the behavior and performance of deep learning models across various learning tasks and network topologies.

With an extensive range of hyperparameter settings, including varying depths, numbers of trainable parameters, learning rates, batch sizes, and regularization penalties, the BUTTER dataset contains 178 thousand hyperparameter configurations, each repeated an average of 20 times, and records 20 performance metrics for each of the 13.1 billion training epochs observed. This extraordinary granularity enables in-depth analysis and comparison of various model training behaviors, aiding the development of energy-efficient deep learning strategies.

An essential aspect of the BUTTER dataset lies in its dedicated focus on understanding energy trends in deep learning practices. As deep learning models find increasing applications in real-world scenarios, energy efficiency becomes a critical concern. By collecting data on energy consumption across different hyperparameter configurations, the BUTTER dataset facilitates the analysis of trade-offs between model performance and energy usage. The insights gained are invaluable for guiding the development of more energy-efficient deep learning strategies, reducing the environmental impact and fostering sustainable adoption of AI technologies.

To ensure the seamless integration of energy-efficient techniques, the proposed development cycle incorporates the evaluation of energy efficiency at each stage, allowing for informed decision-making during model deployment.

\subsection{Improving Interpretability}

Our current research on the Adversarial Observation framework extends to practical applications in validating the robustness of biological neural networks, focusing on chip-seq data analysis. The human genome comprises over 98\% of regulatory elements that do not code for protein-coding genes. These active regulatory regions, including enhancers, play crucial roles in gene transcription, 3-dimensional folding, and other essential biological processes \cite{encode2012integrated}. Enhancers, which amplify gene expression regardless of their precise location, contribute to the formation of distinct cell types in multicellular organisms with identical DNA content.

To identify enhancers, we employ neural network-based approaches that effectively combine DNA-sequence and biochemical assays \cite{chen2021deepcape, srivastava2021interpretable}. Our neural network exclusively relies on chromatin datasets, making it applicable across various cell types and less mutagenic cancers. For model interpretability, we introduce an adversarial particle swarm optimization as an adversarial approach to unveil the neural networks' learning process, revealing common chromatin features at enhancers, independent of cell types.

The cost function is defined in \ref{eq:Chr_cost_func} where we want to maximize the chance of the model predicting the correct label.

\begin{equation}
    \label{eq:Chr_cost_func}
    Cost = f_\theta(x)  
\end{equation}

where 
\begin{enumerate}
    \item $f_\theta(x)$ is the neural network model
    \item x is the input data
\end{enumerate}

By enhancing interpretability, our proposed development cycle aims to provide transparent insights into the decision-making process of machine learning models, fostering trust and facilitating the application of AI technologies in critical domains such as healthcare and genomics.


\begin{figure}
    \centering
    \includegraphics[width=0.8\textwidth]{example-image-c}
    \caption{4x2 Output of APSO over time for predicting enhancers with activation mapping}
    \label{fig:APSO_Over_Time}
\end{figure}


Talk about figure

\subsection{Ensuring Model Security}

In the pursuit of model security, our research focuses on studying the pipeline developed by Goodfellow et al. \cite{goodfellow2014explaining} to incorporate adversarial noise back into the model, effectively enhancing its robustness. This approach relies on the notion that adversarial noise can be leveraged to train a model to be more resilient to adversarial attacks. We conduct this process in parallel with network pruning to ensure that no security vulnerabilities are introduced during the pruning process. By actively bolstering model resilience, we aim to enhance the security of machine learning applications, safeguarding against potential adversarial threats.

To complement adversarial training, we are exploring the integration of generative adversarial noise from the FGSM and APSO for data augmentation to enhance model robustness. By generating synthetic data samples and incorporating them into the training set, the model gains exposure to a broader range of potential input variations, fortifying its ability to handle previously unseen data points and minimizing the risk of overfitting.

In the future we would like to investigate the adoption of privacy-preserving techniques, such as federated learning and differential privacy, to safeguard sensitive data during the model training process. These techniques allow multiple parties to collaboratively train a model without sharing raw data, ensuring data privacy and mitigating the risk of data leakage or unauthorized access.

The integration of security measures into our proposed development cycle ensures that model robustness and protection against security threats remain critical considerations throughout the model's lifecycle.


% \section{Current Work}
% \label{sec:current_work}

% In this section, we discuss our ongoing work and future plans, with a focus on integrating the Adversarial Observation framework into our proposed MLOP development cycle to address its limitations.

% \subsection{Addressing Energy Efficiency}

% Efforts are currently underway to assess energy efficiency using diverse pruning metrics and datasets like the BUTTER dataset \cite{butter_publication, butter_dataset}. The BUTTER dataset, standing for \textit{Better Understanding of Training Topologies through Empirical Research}, provides a comprehensive and empirical exploration of deep learning phenomena on fully-connected networks. It serves as a valuable resource for researchers and practitioners seeking deeper insights into the behavior and performance of deep learning models across various learning tasks and network topologies.

% The BUTTER dataset encompasses an extensive range of hyperparameter settings, including varying depths, numbers of trainable parameters, learning rates, batch sizes, and regularization penalties. With 178 thousand hyperparameter configurations, each repeated an average of 20 times, and 20 performance metrics recorded for each of the 13.1 billion training epochs observed, the BUTTER dataset offers an unprecedented level of granularity for in-depth analysis and comparison of various model training behaviors.

% An essential aspect of the BUTTER dataset is its focus on understanding energy trends in deep learning practices. With the increasing adoption of deep learning models in real-world applications, energy efficiency has become a critical concern. By collecting data on energy consumption across different hyperparameter configurations, the BUTTER dataset enables researchers to analyze the trade-offs between model performance and energy usage. Such insights are invaluable for guiding the development of more energy-efficient deep learning strategies, thereby reducing the environmental impact and facilitating the adoption of AI technologies in sustainable ways.

% \subsection{Improving Interpretability}

% Practical applications of the Adversarial Observation framework include validating the robustness of biological neural networks using chip-seq data. The human genome comprises over 98\% of regulatory elements that don't code for protein-coding genes. These active regulatory regions, including enhancers, play essential roles in gene transcription, 3-dimensional folding, and other biological processes \cite{encode2012integrated}. Enhancers, which amplify gene expression regardless of their precise location, contribute to the formation of distinct cell types in multicellular organisms with identical DNA content.

% Genetic research has shown that disease-associated DNA mutations often occur outside gene-coding regions, potentially disrupting regulatory processes via putative enhancer regions. To identify enhancers, neural network-based approaches have been successful in combining DNA-sequence and biochemical assays \cite{chen2021deepcape, srivastava2021interpretable}. We use a neural network that relies solely on chromatin datasets, making it applicable across various cell types and less mutagenic cancers. Then, to validate our model for interpretability, we introduce a particle swarm optimization (PSO) as an adversarial approach to unveil the neural networks' learning process, revealing common chromatin features at enhancers independent of cell types.

% \subsection{Ensuring Model Security}

% Security is equally crucial in the development and deployment of machine learning models. We are currently studying the use of the pipeline developed by Goodfellow et al. \cite{goodfellow2014explaining} to feed adversarial noise back into the model to improve its robustness. This approach is based on the idea that adversarial noise can be used to train a model to be more resilient to adversarial attacks. This is done in parallel with network pruning to ensure that no security vulnerabilities are introduced during the pruning process. By actively enhancing model resilience, we aim to bolster the security of machine learning applications and protect against potential adversarial threats.
